
CREATE TABLE IF NOT EXISTS `{tablename}_format` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `catid` varchar(255) NOT NULL COMMENT '栏目id',
  `name` varchar(30) NOT NULL COMMENT '规格名称',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='商品规格表';

CREATE TABLE IF NOT EXISTS `{tablename}_format_data` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `fid` smallint(5) unsigned NOT NULL COMMENT '规格id',
  `pid` smallint(5) unsigned NOT NULL COMMENT '父id',
  `name` varchar(20) NOT NULL COMMENT '规格值名称',
  `displayorder` tinyint(3) unsigned NOT NULL COMMENT '排序',
  PRIMARY KEY (`id`),
  KEY `fid` (`fid`,`pid`,`displayorder`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='商品规格值';

CREATE TABLE IF NOT EXISTS `{tablename}_order` (
  `id` bigint(15) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL COMMENT '下订单的uid',
  `username` varchar(50) NOT NULL COMMENT '买家账号',
  `ptid` tinyint(1) unsigned NOT NULL COMMENT '付款方式',
  `score` int(10) unsigned NOT NULL COMMENT '虚拟币',
  `price` decimal(10,2) unsigned NOT NULL COMMENT '价格',
  `shipping` tinyint(1) unsigned NOT NULL COMMENT '运送编号(1快递,2平邮,3EMS)',
  `freight` decimal(5,2) unsigned NOT NULL COMMENT '运费',
  `items` text NOT NULL COMMENT '商品信息',
  `gbook` varchar(255) NOT NULL COMMENT '买家留言',
  `city` mediumint(8) unsigned NOT NULL COMMENT '收货人城市id',
  `name` varchar(50) NOT NULL COMMENT '收货人姓名',
  `phone` varchar(20) NOT NULL COMMENT '收货人电话',
  `zipcode` varchar(10) NOT NULL COMMENT '收货人邮编',
  `address` varchar(255) NOT NULL COMMENT '收货人地址',
  `status` tinyint(1) unsigned NOT NULL,
  `inputtime` int(10) unsigned NOT NULL COMMENT '下单时间',
  `sendnote` varchar(255) NOT NULL COMMENT '发货备注',
  `sendtime` int(10) unsigned NOT NULL COMMENT '发货时间',
  `successtime` int(10) unsigned NOT NULL COMMENT '成功时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='商品订单表';

CREATE TABLE IF NOT EXISTS `{tablename}_order_index` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `oid` bigint(15) unsigned NOT NULL COMMENT '订单id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '买家id',
  `iid` int(10) unsigned NOT NULL COMMENT '商品id',
  `fid` varchar(20) NOT NULL COMMENT '规格编号',
  `review` tinyint(1) unsigned NOT NULL COMMENT '是否评论',
  PRIMARY KEY (`id`),
  KEY `oid` (`oid`,`uid`,`iid`,`fid`,`review`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='订单索引表' AUTO_INCREMENT=3 ;

CREATE TABLE IF NOT EXISTS `{tablename}_order_review` (
  `id` int(10) unsigned NOT NULL,
  `uid` mediumint(8) unsigned NOT NULL COMMENT '买家id',
  `author` varchar(30) NOT NULL COMMENT '买家名',
  `iid` int(10) unsigned NOT NULL COMMENT '商品id',
  `item` text NOT NULL COMMENT '商品信息',
  `value` text NOT NULL COMMENT '点评分数',
  `avgsort` float(3,1) unsigned NOT NULL COMMENT '平均分数',
  `content` text NOT NULL COMMENT '评论内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '评论时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `iid` (`iid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='订单评论表';


REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(1, 3, 1, 8);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(1, 4, 1, 8);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(1, 5, 1, 13);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(1, 6, 1, 12);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(2, 7, 1, 21);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(2, 8, 1, 21);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(2, 9, 1, 21);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(2, 10, 1, 25);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(2, 11, 1, 25);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(2, 12, 1, 25);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(2, 13, 1, 25);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(2, 14, 1, 25);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(1, 8, 1, 21);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(3, 15, 1, 42);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(3, 16, 1, 42);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(3, 17, 1, 42);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(3, 18, 1, 45);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(4, 1, 1, 53);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(4, 2, 1, 53);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(4, 19, 1, 59);
REPLACE INTO `{tablename}_flag` (`flag`, `id`, `uid`, `catid`) VALUES(4, 20, 1, 59);

REPLACE INTO `{tablename}_format_data` VALUES(1, 1, 0, '颜色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(2, 1, 0, '尺寸', 0);
REPLACE INTO `{tablename}_format_data` VALUES(3, 1, 2, '25', 0);
REPLACE INTO `{tablename}_format_data` VALUES(4, 1, 2, '26', 0);
REPLACE INTO `{tablename}_format_data` VALUES(5, 1, 2, '27', 0);
REPLACE INTO `{tablename}_format_data` VALUES(6, 1, 2, '28', 0);
REPLACE INTO `{tablename}_format_data` VALUES(7, 1, 2, '29', 0);
REPLACE INTO `{tablename}_format_data` VALUES(8, 1, 2, '30', 0);
REPLACE INTO `{tablename}_format_data` VALUES(9, 1, 2, '31', 0);
REPLACE INTO `{tablename}_format_data` VALUES(10, 1, 2, '32', 0);
REPLACE INTO `{tablename}_format_data` VALUES(11, 1, 2, '33', 0);
REPLACE INTO `{tablename}_format_data` VALUES(12, 1, 2, '34', 0);
REPLACE INTO `{tablename}_format_data` VALUES(13, 1, 2, '35', 0);
REPLACE INTO `{tablename}_format_data` VALUES(14, 1, 2, '36', 0);
REPLACE INTO `{tablename}_format_data` VALUES(15, 1, 1, '黑色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(16, 1, 1, '白色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(17, 1, 1, '红色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(18, 1, 1, '灰色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(19, 1, 1, '粉红色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(20, 1, 1, '浅灰色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(21, 2, 0, '尺码', 0);
REPLACE INTO `{tablename}_format_data` VALUES(22, 2, 21, '35', 0);
REPLACE INTO `{tablename}_format_data` VALUES(23, 2, 21, '36', 0);
REPLACE INTO `{tablename}_format_data` VALUES(24, 2, 21, '37', 0);
REPLACE INTO `{tablename}_format_data` VALUES(25, 2, 21, '38', 0);
REPLACE INTO `{tablename}_format_data` VALUES(26, 2, 21, '39', 0);
REPLACE INTO `{tablename}_format_data` VALUES(27, 2, 21, '40', 0);
REPLACE INTO `{tablename}_format_data` VALUES(28, 2, 21, '41', 0);
REPLACE INTO `{tablename}_format_data` VALUES(29, 2, 21, '42', 0);
REPLACE INTO `{tablename}_format_data` VALUES(30, 2, 21, '43', 0);
REPLACE INTO `{tablename}_format_data` VALUES(31, 2, 21, '44', 0);
REPLACE INTO `{tablename}_format_data` VALUES(32, 2, 21, '45', 0);
REPLACE INTO `{tablename}_format_data` VALUES(33, 3, 0, '颜色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(34, 3, 0, '容量', 0);
REPLACE INTO `{tablename}_format_data` VALUES(35, 3, 0, '配置', 0);
REPLACE INTO `{tablename}_format_data` VALUES(36, 3, 33, '黑色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(37, 3, 33, '白色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(38, 3, 33, '蓝色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(39, 3, 33, '黄色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(40, 3, 33, '绿色', 0);
REPLACE INTO `{tablename}_format_data` VALUES(41, 3, 34, '8G', 0);
REPLACE INTO `{tablename}_format_data` VALUES(42, 3, 34, '16G', 0);
REPLACE INTO `{tablename}_format_data` VALUES(43, 3, 34, '32G', 0);
REPLACE INTO `{tablename}_format_data` VALUES(44, 3, 34, '64G', 0);
REPLACE INTO `{tablename}_format_data` VALUES(45, 3, 35, '标配', 0);
REPLACE INTO `{tablename}_format_data` VALUES(46, 3, 35, '套餐一', 0);
REPLACE INTO `{tablename}_format_data` VALUES(47, 3, 35, '套餐二', 0);


REPLACE INTO `{tablename}_format` VALUES(1, ',8,9,10,11,12,13,14,15,16,17,18,19,20,', '服装属性');
REPLACE INTO `{tablename}_format` VALUES(2, ',21,22,23,24,32,', '鞋尺码');
REPLACE INTO `{tablename}_format` VALUES(3, ',53,59,', '手机规格');

REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(1, 0, '0', '男女服装', 'n', 'nannufuzhuang', '', 1, '1,8,9,10,11,12,13,14,15,16,17,18,19,20', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(2, 0, '0', '鞋包配饰', 'x', 'xiebaopeishi', '', 1, '2,21,22,23,24,25,26,27,28,29', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(3, 0, '0', '运动户外', 'y', 'yundonghuwai', '', 1, '3,30,31,32,33,34,35,36,37,38,39,40,41', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(4, 0, '0', '美容美妆', 'm', 'meirongmeizhuang', '', 1, '4,42,43,44,45,46,47,48,49,50,51', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(5, 0, '0', '数码家电', 's', 'shumajiadian', '', 1, '5,52,53,54,55,56,57,58,59', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(6, 0, '0', '家居家装', 'j', 'jiajujiazhuang', '', 1, '6,60,61,62,63,64,65,66,67', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(7, 0, '0', '母婴用品', 'm', 'muyingyongpin', '', 1, '7,68,69,70,71,72,73,74,75,76', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(8, 1, '0,1', '男羽绒', 'n', 'nanyurong', 'nannufuzhuang/', 0, '8', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(9, 1, '0,1', '呢大衣', 'n', 'nedayi', 'nannufuzhuang/', 0, '9', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(10, 1, '0,1', '男棉服', 'n', 'nanmianfu', 'nannufuzhuang/', 0, '10', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(11, 1, '0,1', '女羽绒', 'n', 'nuyurong', 'nannufuzhuang/', 0, '11', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(12, 1, '0,1', '牛仔裤', 'n', 'niuzaiku', 'nannufuzhuang/', 0, '12', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(13, 1, '0,1', '女毛衣', 'n', 'numaoyi', 'nannufuzhuang/', 0, '13', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(14, 1, '0,1', '男毛衣', 'n', 'nanmaoyi', 'nannufuzhuang/', 0, '14', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(15, 1, '0,1', '连衣裙', 'l', 'lianyiqun', 'nannufuzhuang/', 0, '15', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(16, 1, '0,1', '男夹克', 'n', 'nanjiake', 'nannufuzhuang/', 0, '16', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(17, 1, '0,1', '女睡衣', 'n', 'nushuiyi', 'nannufuzhuang/', 0, '17', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(18, 1, '0,1', '男睡衣', 'n', 'nanshuiyi', 'nannufuzhuang/', 0, '18', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(19, 1, '0,1', '男士内衣', 'n', 'nanshineiyi', 'nannufuzhuang/', 0, '19', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(20, 1, '0,1', '女士内衣', 'n', 'nushineiyi', 'nannufuzhuang/', 0, '20', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(21, 2, '0,2', '女鞋', 'n', 'nuxie', 'xiebaopeishi/', 0, '21', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(22, 2, '0,2', '男鞋', 'n', 'nanxie', 'xiebaopeishi/', 0, '22', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(23, 2, '0,2', '高跟鞋', 'g', 'gaogenxie', 'xiebaopeishi/', 0, '23', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(24, 2, '0,2', '中长靴', 'z', 'zhongchangxue', 'xiebaopeishi/', 0, '24', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(25, 2, '0,2', '女包', 'n', 'nubao', 'xiebaopeishi/', 0, '25', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(26, 2, '0,2', '双肩包', 's', 'shuangjianbao', 'xiebaopeishi/', 0, '26', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(27, 2, '0,2', '施华洛', 's', 'shihualuo', 'xiebaopeishi/', 0, '27', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(28, 2, '0,2', '钻石', 'z', 'zuanshi', 'xiebaopeishi/', 0, '28', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(29, 2, '0,2', '手表', 's', 'shoubiao', 'xiebaopeishi/', 0, '29', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(30, 3, '0,3', '运动背包', 'y', 'yundongbeibao', 'yundonghuwai/', 0, '30', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(31, 3, '0,3', '户外服装', 'h', 'huwaifuzhuang', 'yundonghuwai/', 0, '31', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(32, 3, '0,3', '户外鞋', 'h', 'huwaixie', 'yundonghuwai/', 0, '32', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(33, 3, '0,3', '运动配件', 'y', 'yundongpeijian', 'yundonghuwai/', 0, '33', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(34, 3, '0,3', '健身器材', 'j', 'jianshenqicai', 'yundonghuwai/', 0, '34', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(35, 3, '0,3', '小型健身器材', 'x', 'xiaoxingjianshenqicai', 'yundonghuwai/', 0, '35', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(36, 3, '0,3', '瑜伽', 'y', 'yuga', 'yundonghuwai/', 0, '36', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(37, 3, '0,3', '轮滑', 'l', 'lunhua', 'yundonghuwai/', 0, '37', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(38, 3, '0,3', '探路者', 't', 'tanluzhe', 'yundonghuwai/', 0, '38', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(39, 3, '0,3', '冲锋衣', 'c', 'chongfengyi', 'yundonghuwai/', 0, '39', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(40, 3, '0,3', '游泳系列', 'y', 'youyongxilie', 'yundonghuwai/', 0, '40', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(41, 3, '0,3', '球类运动', 'q', 'qiuleiyundong', 'yundonghuwai/', 0, '41', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(42, 4, '0,4', '美容', 'm', 'meirong', 'meirongmeizhuang/', 0, '42', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(43, 4, '0,4', '保湿', 'b', 'baoshi', 'meirongmeizhuang/', 0, '43', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(44, 4, '0,4', '抗敏', 'k', 'kangmin', 'meirongmeizhuang/', 0, '44', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(45, 4, '0,4', '洁面', 'j', 'jiemian', 'meirongmeizhuang/', 0, '45', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(46, 4, '0,4', '爽肤水', 's', 'shuangfushui', 'meirongmeizhuang/', 0, '46', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(47, 4, '0,4', '眼霜', 'y', 'yanshuang', 'meirongmeizhuang/', 0, '47', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(48, 4, '0,4', '彩妆', 'c', 'caizhuang', 'meirongmeizhuang/', 0, '48', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(49, 4, '0,4', '男士', 'n', 'nanshi', 'meirongmeizhuang/', 0, '49', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(50, 4, '0,4', '纤体', 'x', 'xianti', 'meirongmeizhuang/', 0, '50', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(51, 4, '0,4', '假发', 'j', 'jiafa', 'meirongmeizhuang/', 0, '51', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(52, 5, '0,5', '笔记本', 'b', 'bijiben', 'shumajiadian/', 0, '52', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(53, 5, '0,5', 'iPhone', 'i', 'iphone', 'shumajiadian/', 0, '53', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(54, 5, '0,5', '相机', 'x', 'xiangji', 'shumajiadian/', 0, '54', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(55, 5, '0,5', 'TF卡', 't', 'tfka', 'shumajiadian/', 0, '55', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(56, 5, '0,5', '蓝牙耳机', 'l', 'lanyaerji', 'shumajiadian/', 0, '56', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(57, 5, '0,5', '键盘', 'j', 'jianpan', 'shumajiadian/', 0, '57', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(58, 5, '0,5', '鼠标', 's', 'shubiao', 'shumajiadian/', 0, '58', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(59, 5, '0,5', '手机', 's', 'shouji', 'shumajiadian/', 0, '59', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(60, 6, '0,6', '十字绣', 's', 'shizixiu', 'jiajujiazhuang/', 0, '60', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(61, 6, '0,6', '四件套', 's', 'sijiantao', 'jiajujiazhuang/', 0, '61', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(62, 6, '0,6', '保健枕', 'b', 'baojianzhen', 'jiajujiazhuang/', 0, '62', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(63, 6, '0,6', '枕头', 'z', 'zhentou', 'jiajujiazhuang/', 0, '63', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(64, 6, '0,6', '水杯', 's', 'shuibei', 'jiajujiazhuang/', 0, '64', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(65, 6, '0,6', '收纳', 's', 'shouna', 'jiajujiazhuang/', 0, '65', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(66, 6, '0,6', '家具', 'j', 'jiaju', 'jiajujiazhuang/', 0, '66', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(67, 6, '0,6', '装潢', 'z', 'zhuangguang', 'jiajujiazhuang/', 0, '67', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(68, 7, '0,7', '婴儿礼盒', 'y', 'yingerlihe', 'muyingyongpin/', 0, '68', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(69, 7, '0,7', '哈衣', 'h', 'hayi', 'muyingyongpin/', 0, '69', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(70, 7, '0,7', '运动套装', 'y', 'yundongtaozhuang', 'muyingyongpin/', 0, '70', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(71, 7, '0,7', '孕妇装', 'y', 'yunfuzhuang', 'muyingyongpin/', 0, '71', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(72, 7, '0,7', '托腹裤', 't', 'tuofuku', 'muyingyongpin/', 0, '72', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(73, 7, '0,7', '孕妇裙', 'y', 'yunfuqun', 'muyingyongpin/', 0, '73', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(74, 7, '0,7', '纸尿裤', 'z', 'zhiniaoku', 'muyingyongpin/', 0, '74', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(75, 7, '0,7', '宝宝食品', 'b', 'baobaoshipin', 'muyingyongpin/', 0, '75', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);
REPLACE INTO `{tablename}_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`) VALUES(76, 7, '0,7', '宝宝玩具', 'b', 'baobaowanju', 'muyingyongpin/', 0, '76', '', 1, NULL, 'a:4:{s:3:\\"seo\\";a:5:{s:7:\\"seojoin\\";s:1:\\"_\\";s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:4:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";}s:7:\\"urlmode\\";s:1:\\"0\\";s:3:\\"url\\";a:5:{s:4:\\"show\\";s:0:\\"\\";s:9:\\"show_page\\";s:0:\\"\\";s:4:\\"list\\";s:0:\\"\\";s:9:\\"list_page\\";s:0:\\"\\";s:7:\\"catjoin\\";s:1:\\"/\\";}}', 0);

REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(1, 53, 'Apple/苹果 iPhone 4S iphone4s 原封 未激活 官方版', 'iphone4s,iPhone,苹果', '', 'http://img.taobaocdn.com/bao/uploaded/i4/T1N_SrXfNxXXaTxD7__110646.jpg_220x220.jpg', '200.00', 3996, 626, '0', 343, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=1', '127.0.0.1', 1381893932, 1381893932, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(2, 53, 'Apple/苹果 iPhone 5s苹果5S三网V版 美版国行 港版 金色5288限量', 'iPhone,苹果', '', 'http://img.taobaocdn.com/bao/uploaded/i3/T1aTKOFbtcXXc9QiUZ_033001.jpg_220x220.jpg', '122.00', 15932, 1, '0', 22, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=2', '127.0.0.1', 1381894303, 1381894303, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(3, 8, 'Afterseven春秋新款韩版男士夹克 潮流修身加大码男装薄休闲外套', '休闲外套,潮流,韩版,男士,男装', '', 'http://gi1.md.alicdn.com/bao/uploaded/i1/12631026148495106/T1WT84FgpdXXXXXXXX_!!0-item_pic.jpg', '123.00', 9281, 2, '0', 212, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=3', '127.0.0.1', 1381903941, 1381903941, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(4, 8, '2013秋冬新品潮流男士羽绒服衬衣男装外套羽绒衫男 以山', '羽绒服,潮流,衬衣,男士,男装', '', 'http://img01.taobaocdn.com/bao/uploaded/i1/15344027311072967/T13gqEFkBfXXXXXXXX_!!0-item_pic.jpg', '23.00', 8314, 248, '0', 122, 1, 0, 1, 1, 'admin', 9, '/shop/index.php?c=show&id=4', '127.0.0.1', 1381904152, 1381904152, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(5, 13, '2013春秋装连衣裙新款 韩版长袖大码显瘦拼接蕾丝连衣裙 限时包邮', '蕾丝连衣裙,连衣裙新款,包邮,长袖,韩版', '', 'http://img04.taobaocdn.com/bao/uploaded/i4/11204025829849686/T1Y88_FXdXXXXXXXXX_!!0-item_pic.jpg', '123.00', 24492, 524, '0', 122, 1, 0, 7, 1, 'admin', 9, '/shop/index.php?c=show&id=5', '127.0.0.1', 1381904292, 1381904292, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(6, 12, '2013春装新款 时尚修身显瘦全棉条纹长袖圆领连衣裙打底裙外套', '连衣裙,长袖,时尚,条纹,新款', '', 'http://img01.taobaocdn.com/bao/uploaded/i1/15807021496885482/T138F8XyFdXXXXXXXX_!!0-item_pic.jpg', '123.00', 258, 248, '0', 122, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=6', '127.0.0.1', 1381904463, 1381904463, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(7, 21, '秋冬新品韩版通勤时尚中高跟粗跟皮带扣防水台真皮女鞋女靴短靴', '防水,韩版,时尚,新品', '', 'http://img04.taobaocdn.com/bao/uploaded/i4/19926028567969889/T1orm1FcheXXXXXXXX_!!0-item_pic.jpg', '12.00', 147, 882, '0', 122, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=7', '127.0.0.1', 1381904664, 1381904664, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(8, 21, '秋季新款欧美短靴新品 真皮单祼靴磨砂牛皮女靴子马丁靴简约女鞋', '马丁靴,靴子,简约,秋季,新款', '', 'http://img01.taobaocdn.com/bao/uploaded/i1/19926029070546881/T1tK_nFn4dXXXXXXXX_!!0-item_pic.jpg', '123.00', 1478, 65, '0', 12, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=8', '127.0.0.1', 1381904802, 1381904802, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(9, 21, '包邮热卖韩版花朵红色高跟鞋婚鞋绿色新娘鞋单鞋结婚鞋子婚纱鞋', '红色高跟鞋,新娘,包邮,单鞋,韩版', '', 'http://img01.taobaocdn.com/bao/uploaded/i1/18026019898766266/T13o0uXqtfXXXXXXXX_!!0-item_pic.jpg', '121.00', 269, 693, '0', 0, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=9', '127.0.0.1', 1381904926, 1381904926, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(10, 25, '新款女包韩版潮包 纯色休闲手提大包糖果色单肩包斜跨包包', '新款女包,单肩包,韩版,休闲', '', 'http://img01.taobaocdn.com/bao/uploaded/i1/10951028968361396/T1RKLlFhdXXXXXXXXX_!!0-item_pic.jpg', '12312.00', 1231, 851, '0', 0, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=10', '127.0.0.1', 1381905071, 1381905071, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(11, 25, '欧美大牌女包包2013新款潮撞色甜美糖果印花finalgirls复古手提包', '手提包,复古,女包,甜美,新款', '', 'http://img02.taobaocdn.com/bao/uploaded/i2/19559028689056714/T1wu2fFflbXXXXXXXX_!!1-item_pic.gif', '1231.00', 12312, 271, '0', 0, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=11', '127.0.0.1', 1381905183, 1381905183, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(12, 25, '新款菱格链条包韩版糖果色包包 真皮单肩斜挎小包 秋冬季女包', '单肩,韩版,女包,小包,新款', '', 'http://img04.taobaocdn.com/bao/uploaded/i4/14810024154237319/T11Kq3Xw0eXXXXXXXX_!!0-item_pic.jpg', '12313.00', 123, 835, '0', 0, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=12', '127.0.0.1', 1381905291, 1381905291, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(13, 25, '小清新款女包包潮流鸵鸟纹撞色女士单肩斜挎pu糖果色甜美晚宴', '潮流,单肩,女包,甜美', '', 'http://img03.taobaocdn.com/bao/uploaded/i3/11957028655465778/T1K9PiFXBeXXXXXXXX_!!0-item_pic.jpg', '1231.00', 123, 836, '0', 0, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=13', '127.0.0.1', 1381905422, 1381905422, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(14, 25, '秋季韩版潮新款糖果色单肩手提斜跨女包包小挎包复古小包', '小挎包,单肩,复古,韩版,女包', '', 'http://img04.taobaocdn.com/bao/uploaded/i4/14410028736686291/T1W6fiFoVdXXXXXXXX_!!0-item_pic.jpg', '444.00', 333, 626, '0', 0, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=14', '127.0.0.1', 1381905538, 1381905538, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(15, 42, '专柜正品 AVON雅芳香品走珠香水限量版 小黑裙/小红裙/小白裙之恋 ', '香水,正品,专柜', '', 'http://gi3.md.alicdn.com/bao/uploaded/i3/12659039022320170/T1HlCoFfFeXXXXXXXX_!!0-item_pic.jpg_310x310.jpg', '12312.00', 123123, 0, '0', 0, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=15', '127.0.0.1', 1381906241, 1381906241, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(16, 42, '法国夏莫尼正品格拉斯魔法香膏 固体香膏 女士香水', '女士香水,格拉斯,法国,正品', '', 'http://img01.taobaocdn.com/bao/uploaded/i1/19114026056555156/T1NGpAFnxeXXXXXXXX_!!0-item_pic.jpg_310x310.jpg', '222.00', 213, 942, '0', 0, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=16', '127.0.0.1', 1381906540, 1381906540, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(17, 42, 'PBA YangSang矿物丝柔散粉13g 蜜粉定妆粉 粉底妆控油裸妆 正品', '粉底,控油,蜜粉,正品', '', 'http://img03.taobaocdn.com/bao/uploaded/i3/19556029081387003/T1fmneFdJeXXXXXXXX_!!0-item_pic.jpg_310x310.jpg', '333.00', 333, 896, '0', 0, 1, 0, 8, 1, 'admin', 9, '/shop/index.php?c=show&id=17', '127.0.0.1', 1381906598, 1381906598, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(18, 45, '正品彼丽七合一裸妆BB霜50G 零毛孔遮暇控油保湿彩妆裸妆', '裸妆BB霜,彩妆,控油,正品', '', 'http://img04.taobaocdn.com/bao/uploaded/i4/19086029468047851/T1S0GxFbJgXXXXXXXX_!!0-item_pic.jpg_310x310.jpg', '555.00', 55, 930, '0', 0, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=18', '127.0.0.1', 1381906727, 1381906727, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(19, 59, 'Huawei/华为 G520 四核安卓智能手机 移动3G 双卡 1G运行 纯净版 ', '智能手机,华为,双卡', '', 'http://img.taobaocdn.com/bao/uploaded/i6/T1od5LFhNbXXc5RhQ0_035502.jpg_220x220.jpg', '222.00', 22, 885, '0', 0, 1, 0, 0, 1, 'admin', 9, '/shop/index.php?c=show&id=19', '127.0.0.1', 1381907143, 1381907143, 0, 0);
REPLACE INTO `{tablename}` (`id`, `catid`, `title`, `keywords`, `description`, `thumb`, `price`, `quantity`, `city`, `freight`, `volume`, `onsale`, `review`, `hits`, `uid`, `author`, `status`, `url`, `inputip`, `inputtime`, `updatetime`, `tableid`, `displayorder`) VALUES(20, 59, '假一赔三MIUI/小米 2S(MI2S)小米2S M2S 16G/32G标准版 电信版 ', '电信', '', 'http://img.taobaocdn.com/bao/uploaded/i3/T145J.Xt4bXXXHPUM__111038.jpg_220x220.jpg', '123.00', 681, 0, '0', 0, 1, 0, 33, 1, 'admin', 9, '/shop/index.php?c=show&id=20', '127.0.0.1', 1381907260, 1381979684, 0, 0);

REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(1, 1, 53, '<p>提醒广大买家那些送软件都是骗人的。</p><p>我们可以给你装1000美元软件。但是你不能用，因为苹果产品装软件需要ID，必须用自己的ID装的软件 <br /></p><p>你才可以让软件升级 更新，你也不可以连接到苹果ITUNES更新系统固件，也就是说你的机器系统不能升级。</p><p>你也不能自己装别的软件了。只要你连接ITUNES后 你的软件就全部没了。</p><p>不更新软件和系统你的机器就是废品一个。请大家不要上当。记住！有问题的卖家一般都会很轻易的答应你退换货</p>', '', 'a:3:{s:4:\\"file\\";a:3:{i:0;s:82:\\"http://img.taobaocdn.com/bao/uploaded/i4/T1N_SrXfNxXXaTxD7__110646.jpg_220x220.jpg\\";i:1;s:82:\\"http://img.taobaocdn.com/bao/uploaded/i8/T1wVGYXiptXXbLmaEW_022451.jpg_220x220.jpg\\";i:2;s:82:\\"http://img.taobaocdn.com/bao/uploaded/i2/T1.oOWXb8lXXbCC6cV_021220.jpg_220x220.jpg\\";}s:3:\\"pan\\";a:3:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";i:2;s:0:\\"\\";}s:5:\\"title\\";a:3:{i:0;s:4:\\"图1\\";i:1;s:5:\\"图22\\";i:2;s:4:\\"图3\\";}}', 'a:4:{s:2:\\"id\\";a:5:{i:0;s:2:\\"36\\";i:1;s:2:\\"37\\";i:2;s:2:\\"41\\";i:3;s:2:\\"42\\";i:4;s:2:\\"45\\";}s:5:\\"price\\";a:4:{s:8:\\"36-41-45\\";s:3:\\"200\\";s:8:\\"36-42-45\\";s:3:\\"300\\";s:8:\\"37-41-45\\";s:3:\\"200\\";s:8:\\"37-42-45\\";s:3:\\"300\\";}s:8:\\"quantity\\";a:4:{s:8:\\"36-41-45\\";s:3:\\"999\\";s:8:\\"36-42-45\\";s:3:\\"999\\";s:8:\\"37-41-45\\";s:3:\\"999\\";s:8:\\"37-42-45\\";s:3:\\"999\\";}s:6:\\"number\\";a:4:{s:8:\\"36-41-45\\";s:0:\\"\\";s:8:\\"36-42-45\\";s:0:\\"\\";s:8:\\"37-41-45\\";s:0:\\"\\";s:8:\\"37-42-45\\";s:0:\\"\\";}}', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(2, 1, 53, '<p>产品名称：Apple/苹果 iPhone 5s &nbsp; &nbsp;<br /></p><p>品牌: Apple/苹果 &nbsp; &nbsp;<br /></p><p>Apple型号: iphone 5S &nbsp; &nbsp;<br /></p><p>手机价格区间: 4000元以上 &nbsp; &nbsp;<br /></p><p>上市时间: 2013年 &nbsp; &nbsp;<br /></p><p>13年上市月份: 9月 &nbsp; &nbsp;<br /></p><p>网络类型: 联通3G GSM/WCDMA(3G) &nbsp; <br /></p><p> 外观样式: 直板 &nbsp; &nbsp;主屏尺寸: 4.0英寸 &nbsp; &nbsp;机身颜色: 白色 黑色 黄色 &nbsp; &nbsp;手机套餐: 官方标配 &nbsp; &nbsp;后置摄像头: 800万 &nbsp; &nbsp;操作系统: iOS &nbsp; &nbsp;高级功能: WIFI上网 GPS导航 &nbsp; &nbsp;宝贝成色: 全新 &nbsp; &nbsp;售后服务: 无售后服务 &nbsp; &nbsp;触摸屏: 电容式触摸屏 &nbsp; &nbsp;运行内存RAM: 1G &nbsp; &nbsp;机身内存: 16G 32G 64G &nbsp; &nbsp;键盘类型: 虚拟触屏键盘 &nbsp; &nbsp;厚度: 超薄(小于9mm) &nbsp; &nbsp;主屏分辨率: 1136x640像素 &nbsp; &nbsp;手机类型: 拍照 智能 3G &nbsp; &nbsp;电池类型: 不可拆卸式电池 &nbsp; &nbsp;摄像头类型: 双摄像头（前后） &nbsp; &nbsp;视频拍摄: 1080P(全高清D5) &nbsp; &nbsp;网络模式: 单卡双模 &nbsp; &nbsp;cpu核心数: 双核 &nbsp; &nbsp;双核cpu频率: 1228MHZ &nbsp; &nbsp;版本: 中国大陆 港澳台 美国 欧洲</p>', '', 'a:3:{s:4:\\"file\\";a:3:{i:0;s:82:\\"http://img.taobaocdn.com/bao/uploaded/i3/T1aTKOFbtcXXc9QiUZ_033001.jpg_220x220.jpg\\";i:1;s:82:\\"http://img.taobaocdn.com/bao/uploaded/i8/T1JkiOFe4eXXcYByZZ_033004.jpg_220x220.jpg\\";i:2;s:82:\\"http://img.taobaocdn.com/bao/uploaded/i5/T11nqNFhXfXXcbqJAZ_032014.jpg_220x220.jpg\\";}s:3:\\"pan\\";a:3:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";i:2;s:0:\\"\\";}s:5:\\"title\\";a:3:{i:0;s:3:\\"111\\";i:1;s:3:\\"222\\";i:2;s:3:\\"333\\";}}', 'a:4:{s:2:\\"id\\";a:8:{i:0;s:2:\\"36\\";i:1;s:2:\\"37\\";i:2;s:2:\\"38\\";i:3;s:2:\\"39\\";i:4;s:2:\\"40\\";i:5;s:2:\\"42\\";i:6;s:2:\\"43\\";i:7;s:2:\\"45\\";}s:5:\\"price\\";a:10:{s:8:\\"36-42-45\\";s:3:\\"122\\";s:8:\\"36-43-45\\";s:3:\\"123\\";s:8:\\"37-42-45\\";s:3:\\"123\\";s:8:\\"37-43-45\\";s:3:\\"123\\";s:8:\\"38-42-45\\";s:3:\\"123\\";s:8:\\"38-43-45\\";s:3:\\"123\\";s:8:\\"39-42-45\\";s:5:\\"23123\\";s:8:\\"39-43-45\\";s:5:\\"12312\\";s:8:\\"40-42-45\\";s:4:\\"3123\\";s:8:\\"40-43-45\\";s:4:\\"1231\\";}s:8:\\"quantity\\";a:10:{s:8:\\"36-42-45\\";s:3:\\"222\\";s:8:\\"36-43-45\\";s:4:\\"1231\\";s:8:\\"37-42-45\\";s:3:\\"213\\";s:8:\\"37-43-45\\";s:3:\\"123\\";s:8:\\"38-42-45\\";s:3:\\"231\\";s:8:\\"38-43-45\\";s:4:\\"1231\\";s:8:\\"39-42-45\\";s:3:\\"123\\";s:8:\\"39-43-45\\";s:5:\\"12312\\";s:8:\\"40-42-45\\";s:3:\\"123\\";s:8:\\"40-43-45\\";s:3:\\"123\\";}s:6:\\"number\\";a:10:{s:8:\\"36-42-45\\";s:0:\\"\\";s:8:\\"36-43-45\\";s:0:\\"\\";s:8:\\"37-42-45\\";s:0:\\"\\";s:8:\\"37-43-45\\";s:0:\\"\\";s:8:\\"38-42-45\\";s:0:\\"\\";s:8:\\"38-43-45\\";s:0:\\"\\";s:8:\\"39-42-45\\";s:0:\\"\\";s:8:\\"39-43-45\\";s:0:\\"\\";s:8:\\"40-42-45\\";s:0:\\"\\";s:8:\\"40-43-45\\";s:0:\\"\\";}}', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(3, 1, 8, '<p>来自韩国的原版设计，品质通过国家权威质检机构质检！</p><p>此款宝贝是2013韩国官网新款，上身效果超帅，已经有一万多人收藏，火爆销售3000多件！<br /></p><p>收藏和销量就是品质的保证！</p><p><br/></p><p>亲们的喜爱之情人类已经无法阻挡，</p><p>我和我的小伙伴们都惊呆了！<br /></p><p>初秋休闲外套时尚首选！肩部和袖子设计部分拼皮，</p><p>低调品位中带点个性不羁，</p><p>赋予出类拔萃的英伦气质，</p><p>彰显男人绅士，儒雅，成熟，奔放的态度！</p><p>不盲目跟风，我自是潮流！</p><p>现货已经不多，欲购从速！</p><p><br /></p>', '', 'a:3:{s:4:\\"file\\";a:3:{i:0;s:94:\\"http://gi1.md.alicdn.com/bao/uploaded/i1/12631026148495106/T1WT84FgpdXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:81:\\"http://gi4.md.alicdn.com/imgextra/i4/626842631/T2K5iWXkFbXXXXXXXX_!!626842631.jpg\\";i:2;s:81:\\"http://gi3.md.alicdn.com/imgextra/i3/626842631/T2XUAJXexaXXXXXXXX_!!626842631.jpg\\";}s:3:\\"pan\\";a:3:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";i:2;s:0:\\"\\";}s:5:\\"title\\";a:3:{i:0;s:6:\\"121323\\";i:1;s:5:\\"12323\\";i:2;s:7:\\"2131231\\";}}', 'a:4:{s:2:\\"id\\";a:6:{i:0;s:2:\\"15\\";i:1;s:2:\\"16\\";i:2;s:1:\\"3\\";i:3;s:1:\\"4\\";i:4;s:1:\\"5\\";i:5;s:1:\\"6\\";}s:5:\\"price\\";a:8:{s:4:\\"15-3\\";s:3:\\"123\\";s:4:\\"15-4\\";s:4:\\"1231\\";s:4:\\"15-5\\";s:4:\\"2312\\";s:4:\\"15-6\\";s:5:\\"12312\\";s:4:\\"16-3\\";s:3:\\"123\\";s:4:\\"16-4\\";s:4:\\"1231\\";s:4:\\"16-5\\";s:3:\\"123\\";s:4:\\"16-6\\";s:3:\\"123\\";}s:8:\\"quantity\\";a:8:{s:4:\\"15-3\\";s:3:\\"123\\";s:4:\\"15-4\\";s:3:\\"231\\";s:4:\\"15-5\\";s:4:\\"3123\\";s:4:\\"15-6\\";s:4:\\"3123\\";s:4:\\"16-3\\";s:3:\\"123\\";s:4:\\"16-4\\";s:4:\\"2312\\";s:4:\\"16-5\\";s:3:\\"123\\";s:4:\\"16-6\\";s:3:\\"123\\";}s:6:\\"number\\";a:8:{s:4:\\"15-3\\";s:0:\\"\\";s:4:\\"15-4\\";s:0:\\"\\";s:4:\\"15-5\\";s:0:\\"\\";s:4:\\"15-6\\";s:0:\\"\\";s:4:\\"16-3\\";s:0:\\"\\";s:4:\\"16-4\\";s:0:\\"\\";s:4:\\"16-5\\";s:0:\\"\\";s:4:\\"16-6\\";s:0:\\"\\";}}', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(4, 1, 8, '<p><strong><span style="color:#ffffff;"><span style="font-size:36.0px;"><span style="background-color:#ff0000;">拍下89元，亏本冲人气。</span></span></span></strong></p><p><strong><span style="color:#ffffff;"><span style="font-size:36.0px;"><span style="background-color:#ff0000;">百分百保证LIHOMME正品,没有虚的，就是赚人气。</span></span></span></strong></p><p><strong><span style="color:#ffffff;"><span style="font-size:36.0px;"><span style="background-color:#ff0000;">不议价，不包邮，中差评误拍，谢谢！</span></span></span></strong></p><p><span style="color:#ffffff;"><span style="font-size:36.0px;"><span style="background-color:#ff0000;">人气商品亏本冲销量。</span></span></span></p><p><strong><span style="color:#ffffff;"><span style="font-size:36.0px;"><span style="background-color:#ff0000;"><span style="background-color:#ffff00;"><span style="background-color:#000000;">本款还有3XL,4XL,5XL，如需大码联系客服。</span></span></span></span></span></strong></p><p><br /></p>', '', 'a:3:{s:4:\\"file\\";a:2:{i:0;s:85:\\"http://img02.taobaocdn.com/imgextra/i2/1033845344/T2yS4SXrFXXXXXXXXX_!!1033845344.jpg\\";i:1;s:85:\\"http://img04.taobaocdn.com/imgextra/i4/1033845344/T2KWRTXstXXXXXXXXX_!!1033845344.jpg\\";}s:3:\\"pan\\";a:2:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";}s:5:\\"title\\";a:2:{i:0;s:6:\\"123123\\";i:1;s:5:\\"12313\\";}}', 'a:4:{s:2:\\"id\\";a:4:{i:0;s:2:\\"15\\";i:1;s:2:\\"16\\";i:2;s:1:\\"3\\";i:3;s:1:\\"4\\";}s:5:\\"price\\";a:4:{s:4:\\"15-3\\";s:2:\\"23\\";s:4:\\"15-4\\";s:3:\\"234\\";s:4:\\"16-3\\";s:4:\\"2342\\";s:4:\\"16-4\\";s:3:\\"423\\";}s:8:\\"quantity\\";a:4:{s:4:\\"15-3\\";s:4:\\"4234\\";s:4:\\"15-4\\";s:3:\\"234\\";s:4:\\"16-3\\";s:4:\\"3423\\";s:4:\\"16-4\\";s:3:\\"423\\";}s:6:\\"number\\";a:4:{s:4:\\"15-3\\";s:0:\\"\\";s:4:\\"15-4\\";s:0:\\"\\";s:4:\\"16-3\\";s:0:\\"\\";s:4:\\"16-4\\";s:0:\\"\\";}}', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(5, 1, 13, '<ul class="attributes-list list-paddingleft-2"><li title=" 自主实拍图"><p>主图来源: 自主实拍图</p></li><li title=" w0021"><p>货号: w0021</p></li><li title=" 通勤"><p>风格: 通勤</p></li><li title=" 韩版"><p>通勤: 韩版</p></li><li title=" 单件"><p>组合形式: 单件</p></li><li title=" 短裙(76-90厘米)"><p>裙长: 短裙(76-90厘米)</p></li><li title=" 长袖"><p>袖长: 长袖</p></li><li title=" 圆领"><p>领型: 圆领</p></li><li title=" 常规袖"><p>袖型: 常规袖</p></li><li title=" 套头"><p>衣门襟: 套头</p></li><li title=" 拼贴/拼接"><p>流行元素/工艺: 拼贴/拼接</p></li><li title=" 51%-70%"><p>主成份含量: 51%-70%</p></li><li title=" 棉"><p>主材质: 棉</p></li><li title=" 全黑色 上白下黑"><p>颜色分类: 全黑色 上白下黑</p></li><li title=" S（3天后发货） M（3天后发货） L（3天后发货） XL XXL XXXL"><p>尺码: S（3天后发货） M（3天后发货</p></li></ul>', '', 'a:3:{s:4:\\"file\\";a:3:{i:0;s:96:\\"http://img04.taobaocdn.com/bao/uploaded/i4/11204025829849686/T1Y88_FXdXXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:83:\\"http://img03.taobaocdn.com/imgextra/i3/705331204/T2rxoOXbxXXXXXXXXX_!!705331204.jpg\\";i:2;s:83:\\"http://img01.taobaocdn.com/imgextra/i1/705331204/T2pQMOXdhXXXXXXXXX_!!705331204.jpg\\";}s:3:\\"pan\\";a:3:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";i:2;s:0:\\"\\";}s:5:\\"title\\";a:3:{i:0;s:6:\\"123123\\";i:1;s:6:\\"123123\\";i:2;s:7:\\"1231234\\";}}', 'a:4:{s:2:\\"id\\";a:4:{i:0;s:2:\\"15\\";i:1;s:2:\\"16\\";i:2;s:1:\\"3\\";i:3;s:1:\\"4\\";}s:5:\\"price\\";a:4:{s:4:\\"15-3\\";s:3:\\"123\\";s:4:\\"15-4\\";s:4:\\"1231\\";s:4:\\"16-3\\";s:3:\\"123\\";s:4:\\"16-4\\";s:3:\\"123\\";}s:8:\\"quantity\\";a:4:{s:4:\\"15-3\\";s:3:\\"123\\";s:4:\\"15-4\\";s:5:\\"23123\\";s:4:\\"16-3\\";s:4:\\"1123\\";s:4:\\"16-4\\";s:3:\\"123\\";}s:6:\\"number\\";a:4:{s:4:\\"15-3\\";s:0:\\"\\";s:4:\\"15-4\\";s:0:\\"\\";s:4:\\"16-3\\";s:0:\\"\\";s:4:\\"16-4\\";s:0:\\"\\";}}', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(6, 1, 12, '<h2>我们初春上的这款连衣裙采用优质的彩棉羊毛绒面料（非毛线）， &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;色彩清新淡雅，很上档次的！</h2><h2> &nbsp; &nbsp;不是市面上那种含涤纶的羊毛绒磨毛，我们是定织定染的纯棉的，</h2><h2> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;这种面料我们是给外贸做的出口的，</h2><h2><span style="background-color:#ffff00;">不掉色不起球的，大家可以拿样比较一下奥！</span></h2><h2><span style="background-color:#ffff00;"> &nbsp;此款连衣裙采用当季最流行的条纹拼接时尚设计</span></h2><h2><br /><span style="background-color:#ff0000;">本店郑重声明</span></h2><h2>这款衣服版型和质量都是非常的好</h2><h2>敢和淘宝商城去比质量 ，版型和做工如果比他差，我退款</h2><h2>我想和看到的亲说，这款yy在淘宝里面质量，版型都属一流，价格确是很低很低，我们是工厂直销把最大的利润让给了亲们，让亲们用事实说话，帮我们口碑流传！谢谢！</h2><p><img id="1" class="ke_anchor" name="ids-tag-m-1" src="http://www.fc2.com/member/uploadfile/201310/d7440b8288.gif" /></p><p><strong><span style="color:#ff0000;"><span style="font-size:36.0px;">s码适合体重80-95左右， &nbsp; &nbsp;m码适合体重95-110左右， &nbsp; &nbsp;L码适合体重110-125 左右</span></span></strong></p><p><br /></p>', '', 'a:3:{s:4:\\"file\\";a:2:{i:0;s:96:\\"http://img01.taobaocdn.com/bao/uploaded/i1/15807021496885482/T138F8XyFdXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:83:\\"http://img01.taobaocdn.com/imgextra/i1/788745807/T2pJzsXklaXXXXXXXX_!!788745807.jpg\\";}s:3:\\"pan\\";a:2:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";}s:5:\\"title\\";a:2:{i:0;s:6:\\"123123\\";i:1;s:5:\\"33232\\";}}', 'a:4:{s:2:\\"id\\";a:4:{i:0;s:2:\\"15\\";i:1;s:1:\\"3\\";i:2;s:1:\\"4\\";i:3;s:1:\\"5\\";}s:5:\\"price\\";a:3:{s:4:\\"15-3\\";s:3:\\"123\\";s:4:\\"15-4\\";s:3:\\"123\\";s:4:\\"15-5\\";s:3:\\"123\\";}s:8:\\"quantity\\";a:3:{s:4:\\"15-3\\";s:2:\\"12\\";s:4:\\"15-4\\";s:3:\\"123\\";s:4:\\"15-5\\";s:3:\\"123\\";}s:6:\\"number\\";a:3:{s:4:\\"15-3\\";s:0:\\"\\";s:4:\\"15-4\\";s:0:\\"\\";s:4:\\"15-5\\";s:0:\\"\\";}}', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(7, 1, 21, '<div>辛辣的个性风格完美詮释女孩的时尚度</div><div></div><div> 时髦风尚的系带设计~复古英伦的贵族氛围，立即佔据心中的主角级</div><div></div><div>帅气真皮邦带，不仅好穿好脱满分优点</div><div></div><div>展现浓浓的时尚造型，交织出有别以往的简约魅力</div><div></div><div>完美圆楦8cm高挑系跟+耐磨防滑大底</div><div></div><div>前高后高完美线条，虽然是高跟也能走的稳定舒适育！</div><div></div><div>轻鬆修饰令人在意的腿部线条，大方show出性感修长双腿</div><div></div><div>Cool vs. Sexy的时尚英伦风格</div><div></div><div>搭配短裤，丝袜，内搭裤实搭有型的风尚LOOK</div><div></div><span style="line-height:1.5;">全牛皮！还有完善的售后让您消掉后顾之忧！现在仅售全网最低的</span><span style="line-height:1.5;">，还在犹豫吗？</span><p><br /></p>', '', 'a:3:{s:4:\\"file\\";a:3:{i:0;s:96:\\"http://img04.taobaocdn.com/bao/uploaded/i4/19926028567969889/T1orm1FcheXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:92:\\"http://img03.taobaocdn.com/imgextra/i3/19926029029143203/T1VuS_FbBdXXXXXXXX_!!0-item_pic.jpg\\";i:2;s:81:\\"http://img01.taobaocdn.com/imgextra/i1/12209926/T2E3DaXmVaXXXXXXXX_!!12209926.jpg\\";}s:3:\\"pan\\";a:3:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";i:2;s:0:\\"\\";}s:5:\\"title\\";a:3:{i:0;s:8:\\"12312323\\";i:1;s:6:\\"123123\\";i:2;s:6:\\"123123\\";}}', 'a:4:{s:2:\\"id\\";a:3:{i:0;s:2:\\"22\\";i:1;s:2:\\"23\\";i:2;s:2:\\"24\\";}s:5:\\"price\\";a:3:{i:22;s:3:\\"123\\";i:23;s:2:\\"12\\";i:24;s:3:\\"123\\";}s:8:\\"quantity\\";a:3:{i:22;s:3:\\"123\\";i:23;s:2:\\"12\\";i:24;s:2:\\"12\\";}s:6:\\"number\\";a:3:{i:22;s:0:\\"\\";i:23;s:0:\\"\\";i:24;s:0:\\"\\";}}', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(8, 1, 21, '<p><span style="font-size:36.0px;"><span style="color:#9900ff;"><span style="color:#990000;">新款驾到</span>！！</span></span></p><p><span style="font-size:36.0px;"><span style="color:#9900ff;">喜欢的赶紧拍下哦，刚到数量不多。蓝色上脚确实好看</span></span></p><p><br /></p>', '', 'a:3:{s:4:\\"file\\";a:3:{i:0;s:96:\\"http://img01.taobaocdn.com/bao/uploaded/i1/19926029070546881/T1tK_nFn4dXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:81:\\"http://img02.taobaocdn.com/imgextra/i2/12209926/T282H3XgNbXXXXXXXX_!!12209926.jpg\\";i:2;s:81:\\"http://img02.taobaocdn.com/imgextra/i2/12209926/T2_9f_XX8bXXXXXXXX_!!12209926.jpg\\";}s:3:\\"pan\\";a:3:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";i:2;s:0:\\"\\";}s:5:\\"title\\";a:3:{i:0;s:4:\\"1223\\";i:1;s:6:\\"123123\\";i:2;s:5:\\"23234\\";}}', 'a:4:{s:2:\\"id\\";a:3:{i:0;s:2:\\"23\\";i:1;s:2:\\"24\\";i:2;s:2:\\"25\\";}s:5:\\"price\\";a:3:{i:23;s:3:\\"123\\";i:24;s:3:\\"123\\";i:25;s:3:\\"123\\";}s:8:\\"quantity\\";a:3:{i:23;s:3:\\"123\\";i:24;s:3:\\"123\\";i:25;s:4:\\"1232\\";}s:6:\\"number\\";a:3:{i:23;s:0:\\"\\";i:24;s:0:\\"\\";i:25;s:0:\\"\\";}}', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(9, 1, 21, '<p><span style="font-size:24.0px;"><span style="font-family:simhei;">花朵设计，优雅大方，</span></span></p><p style="text-align:center;"><span style="color:#ff0000;"><span style="font-size:24.0px;"><span style="font-family:simhei;">尽显新娘高贵典雅的气质，是结婚婚纱旗袍的完美搭配，</span></span></span></p><p style="text-align:center;"><span style="font-size:24.0px;"><span style="font-family:simhei;">让每一位新娘在这紧张而幸福的时刻，</span></span></p><p style="text-align:center;"><span style="font-size:24.0px;"><span style="font-family:simhei;">更加魅力迷人。</span></span></p><p style="text-align:center;"><span style="color:#ff9900;"><span style="font-size:24.0px;"><span style="font-family:simhei;">脚面的鞋带设计，可以轻松实现一鞋两穿，</span></span><span style="font-size:24.0px;"><span style="font-family:simhei;">多种风情。</span></span></span></p><p style="text-align:center;"><span style="font-size:24.0px;"><span style="font-family:simhei;">特别推荐脚瘦的MM，不要再害怕脚瘦，鞋子不跟脚的尴尬！</span></span></p><p style="text-align:center;"><span style="color:#ff9900;"><span style="font-size:24.0px;"><span style="font-family:simhei;">小小的一根带子，让鞋子服服帖帖，让您无忧做漂亮新娘！</span></span></span></p><p style="text-align:center;"><span style="color:#ff0000;"><span style="font-size:24.0px;"><span style="font-family:simhei;">高跟婚鞋：</span></span></span></p><p style="text-align:center;"><span style="color:#ff0000;"><span style="font-size:24.0px;"><span style="font-family:simhei;">货号：189-16</span></span></span></p><p style="text-align:center;"><span style="color:#ff0000;"><span style="font-size:24.0px;"><span style="font-family:simhei;">跟高：8-12CM</span></span></span></p><p><br /></p>', '', 'a:3:{s:4:\\"file\\";a:3:{i:0;s:96:\\"http://img01.taobaocdn.com/bao/uploaded/i1/18026019898766266/T13o0uXqtfXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:83:\\"http://img02.taobaocdn.com/imgextra/i2/670298026/T2iPlhXr0XXXXXXXXX_!!670298026.jpg\\";i:2;s:83:\\"http://img04.taobaocdn.com/imgextra/i4/670298026/T2eg7QXg8aXXXXXXXX_!!670298026.jpg\\";}s:3:\\"pan\\";a:3:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";i:2;s:0:\\"\\";}s:5:\\"title\\";a:3:{i:0;s:6:\\"123123\\";i:1;s:6:\\"123123\\";i:2;s:9:\\"121323123\\";}}', 'a:4:{s:2:\\"id\\";a:3:{i:0;s:2:\\"23\\";i:1;s:2:\\"24\\";i:2;s:2:\\"25\\";}s:5:\\"price\\";a:3:{i:23;s:3:\\"123\\";i:24;s:3:\\"121\\";i:25;s:3:\\"123\\";}s:8:\\"quantity\\";a:3:{i:23;s:3:\\"123\\";i:24;s:3:\\"123\\";i:25;s:2:\\"23\\";}s:6:\\"number\\";a:3:{i:23;s:0:\\"\\";i:24;s:0:\\"\\";i:25;s:0:\\"\\";}}', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(10, 1, 25, '<p>感谢亲们在淘宝这个大坑中找到了我们。小店需要各位亲们的支持哦当亲们找到这款包包是我们的荣幸如果亲们对这款包包感兴趣可以联系店长了解细节 <br /></p><p>感谢亲的光临</p><p>------------------------------------------------------------------------------------------</p><p>*关于MIXIUBAG*</p><p><br /></p><p>卖自己喜欢的东西 遇眼光相似的人</p><p><br /></p><p>心灵相通的感悟加上竭诚服务的真心</p><p>我们不需要华丽的图片，疯狂的销量</p><p><br /></p><p>需要的是各位亲的青睐<br />我的MIXIU小铺<br />让生活更加美好</p><p>------------------------------------------------------------------------------------------</p><p><br /></p><p>关于快递：小店默认圆通，全峰快递。不到的地方或需要发其他快递的请亲务必告知客服。</p><p>西藏，新疆，青海，贵州等不参加任何包邮活动，发货需要补邮费差价哦</p><p><br /></p><p>------------------------------------------------------------------------------------------</p><p>我们的保证：保证超强质量，保证描述一致，保证精细做工！绝不偷工减料。</p><p><br /></p><p>我们的承诺：只要有任何质量问题，无需理由，我们都会负责承担退货费用！</p><p><br /></p><p>我们的服务：我们已经加入消费者保障和七天无理由退换服务！亲还在等什么！</p><p><br /></p><p><br /></p>', 'Nd1231231', 'a:3:{s:4:\\"file\\";a:1:{i:0;s:96:\\"http://img01.taobaocdn.com/bao/uploaded/i1/10951028968361396/T1RKLlFhdXXXXXXXXX_!!0-item_pic.jpg\\";}s:3:\\"pan\\";a:1:{i:0;s:0:\\"\\";}s:5:\\"title\\";a:1:{i:0;s:9:\\"123123123\\";}}', '', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(11, 1, 25, '<div id="attributes" class="attributes"><ul class="attributes-list list-paddingleft-2"><li title=" 青年"><p>适用人群: 青年</p></li><li title=" 女"><p>性别: 女</p></li><li title=" 手提包"><p>款式: 手提包</p></li><li title=" PU"><p>质地: PU</p></li><li title=" 亮面"><p>PU特征: 亮面</p></li><li title=" 硬把"><p>提拎部件: 硬把</p></li><li title=" 拉链"><p>箱包开袋方式: 拉链</p></li><li title=" 拉链暗袋 手机袋 证件袋 相机插袋"><p>内部结构: 拉链暗袋 手机袋 证件袋 相机插袋</p></li><li title=" 内贴袋"><p>外袋种类: 内贴袋</p></li><li title=" 撞色"><p>流行元素: 撞色</p></li><li title=" 纯色无图案"><p>箱包图案: 纯色无图案</p></li><li title=" 玫瑰红 海之蓝 靓丽红 俏丽粉 优雅杏"><p>颜色分类: 玫瑰红 海之蓝 靓丽红 俏丽粉 优雅杏</p></li><li title=" 有"><p>有无夹层: 有</p></li><li title=" 硬"><p>硬度: 硬</p></li><li title=" 否"><p>可否折叠: 否</p></li><li title=" 101-300元"><p>价格区间: 101-300元</p></li><li title=" 全新"><p>成色: 全新</p></li><li title=" 休闲/街头"><p>箱包场合: 休闲/街头</p></li><li title=" 中（最长边30-50cm）"><p>包袋大小: 中（最长边30-50cm）</p></li><li title=" 最终女孩"><p>品牌: 最终女孩</p></li><li title=" 复古风"><p>箱包风格: 复古风</p></li><li title=" 横款方形"><p>箱包外形: 横款方形</p></li><li title=" 单根"><p>箱包肩带样式: 单根</p></li><li title=" 涤棉"><p>里料质地: 涤棉</p></li></ul></div><p><br /></p>', 'Ga1231231', 'a:3:{s:4:\\"file\\";a:1:{i:0;s:96:\\"http://img02.taobaocdn.com/bao/uploaded/i2/19559028689056714/T1wu2fFflbXXXXXXXX_!!1-item_pic.gif\\";}s:3:\\"pan\\";a:1:{i:0;s:0:\\"\\";}s:5:\\"title\\";a:1:{i:0;s:8:\\"12312313\\";}}', '', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(12, 1, 25, '<div id="attributes" class="attributes"><ul class="attributes-list list-paddingleft-2"><li title=" 女"><p>性别: 女</p></li><li title=" 单肩包"><p>款式: 单肩包</p></li><li title=" 单肩手提"><p>背包方式: 单肩手提</p></li><li title=" 羊皮"><p>质地: 羊皮</p></li><li title=" 锁链式提把"><p>提拎部件: 锁链式提把</p></li><li title=" 拉链"><p>箱包开袋方式: 拉链</p></li><li title=" 拉链暗袋"><p>内部结构: 拉链暗袋</p></li><li title=" 立体袋"><p>外袋种类: 立体袋</p></li><li title=" 菱格"><p>流行元素: 菱格</p></li><li title=" 纯色无图案"><p>箱包图案: 纯色无图案</p></li><li title=" 果绿 玫红色 蓝色"><p>颜色分类: 果绿 玫红色 蓝色</p></li><li title=" 有"><p>有无夹层: 有</p></li><li title=" 软"><p>硬度: 软</p></li><li title=" 否"><p>可否折叠: 否</p></li><li title=" 501-2000元"><p>价格区间: 501-2000元</p></li><li title=" 全新"><p>成色: 全新</p></li><li title=" 休闲/街头"><p>箱包场合: 休闲/街头</p></li><li title=" 小（最长边20-30cm）"><p>包袋大小: 小（最长边20-30cm）</p></li><li title=" 艾泽拉斯 Aziroth"><p>品牌: 艾泽拉斯 Aziroth</p></li><li title=" AST1313"><p>货号: AST1313</p></li><li title=" 小清新"><p>箱包风格: 小清新</p></li><li title=" 横款方形"><p>箱包外形: 横款方形</p></li><li title=" 涤棉"><p>里料质地: 涤棉</p></li><li title=" 28cm长x20cm高x10cm宽"><p>箱包尺寸: 28cm长x20cm高x10cm宽</p></li></ul></div><p><br /></p>', 'NT1231231', 'a:3:{s:4:\\"file\\";a:3:{i:0;s:96:\\"http://img04.taobaocdn.com/bao/uploaded/i4/14810024154237319/T11Kq3Xw0eXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:92:\\"http://img02.taobaocdn.com/imgextra/i2/14810025425911758/T1_yyOXwdaXXXXXXXX_!!0-item_pic.jpg\\";i:2;s:83:\\"http://img03.taobaocdn.com/imgextra/i3/760894810/T2GEj8XaxXXXXXXXXX_!!760894810.jpg\\";}s:3:\\"pan\\";a:3:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";i:2;s:0:\\"\\";}s:5:\\"title\\";a:3:{i:0;s:4:\\"1`21\\";i:1;s:4:\\"1232\\";i:2;s:7:\\"1231231\\";}}', '', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(13, 1, 25, '<div id="attributes" class="attributes"><ul class="attributes-list list-paddingleft-2"><li title=" 女"><p>性别: 女</p></li><li title=" 手提包"><p>款式: 手提包</p></li><li title=" PU"><p>质地: PU</p></li><li title=" 软面"><p>PU特征: 软面</p></li><li title=" 软把"><p>提拎部件: 软把</p></li><li title=" 拉链"><p>箱包开袋方式: 拉链</p></li><li title=" 拉链暗袋 手机袋 证件袋 夹层拉链袋"><p>内部结构: 拉链暗袋 手机袋 证件袋 夹层拉链袋</p></li><li title=" 带盖袋"><p>外袋种类: 带盖袋</p></li><li title=" 撞色"><p>流行元素: 撞色</p></li><li title=" 纯色无图案"><p>箱包图案: 纯色无图案</p></li><li title=" 桔黄 桔红 绿色 明黄 黑色 杏粉 蓝色 玫红 米色"><p>颜色分类: 桔黄 桔红 绿色 明黄 黑色 杏粉 蓝色 玫红 米色</p></li><li title=" 有"><p>有无夹层: 有</p></li><li title=" 软"><p>硬度: 软</p></li><li title=" 可"><p>可否折叠: 可</p></li><li title=" 100元以下"><p>价格区间: 100元以下</p></li><li title=" 全新"><p>成色: 全新</p></li><li title=" 休闲/街头"><p>箱包场合: 休闲/街头</p></li><li title=" 中（最长边30-50cm）"><p>包袋大小: 中（最长边30-50cm）</p></li><li title=" sunnyshop/阳光美包"><p>品牌: sunnyshop/阳光美包</p></li><li title=" 352"><p>货号: 352</p></li><li title=" 日韩风范"><p>箱包风格: 日韩风范</p></li><li title=" 横款方形"><p>箱包外形: 横款方形</p></li><li title=" 单根"><p>箱包肩带样式: 单根</p></li><li title=" 涤纶"><p>里料质地: 涤纶</p></li><li title=" 30cm长x21cm高x13cm宽"><p>箱包尺寸: 30cm长x21cm高x13cm宽</p></li></ul></div><p><br /></p>', '1231231', 'a:3:{s:4:\\"file\\";a:3:{i:0;s:96:\\"http://img03.taobaocdn.com/bao/uploaded/i3/11957028655465778/T1K9PiFXBeXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:81:\\"http://img01.taobaocdn.com/imgextra/i1/52171957/T2GgRGXqdXXXXXXXXX_!!52171957.jpg\\";i:2;s:81:\\"http://img04.taobaocdn.com/imgextra/i4/52171957/T24xNFXyxXXXXXXXXX_!!52171957.jpg\\";}s:3:\\"pan\\";a:3:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";i:2;s:0:\\"\\";}s:5:\\"title\\";a:3:{i:0;s:4:\\"1111\\";i:1;s:4:\\"2222\\";i:2;s:3:\\"333\\";}}', '', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(14, 1, 25, '<div id="attributes" class="attributes"><ul class="attributes-list list-paddingleft-2"><li title=" 青年"><p>适用人群: 青年</p></li><li title=" 女"><p>性别: 女</p></li><li title=" 斜挎包"><p>款式: 斜挎包</p></li><li title=" 斜挎手提"><p>背包方式: 斜挎手提</p></li><li title=" 牛皮"><p>质地: 牛皮</p></li><li title=" 牛二层皮"><p>材质特征: 牛二层皮</p></li><li title=" 装卸式提把"><p>提拎部件: 装卸式提把</p></li><li title=" 拉链"><p>箱包开袋方式: 拉链</p></li><li title=" 拉链暗袋 手机袋 证件袋"><p>内部结构: 拉链暗袋 手机袋 证件袋</p></li><li title=" 内贴袋"><p>外袋种类: 内贴袋</p></li><li title=" 糖果"><p>流行元素: 糖果</p></li><li title=" 纯色无图案"><p>箱包图案: 纯色无图案</p></li><li title=" 浅绿色 米白 粉红 黄色"><p>颜色分类: 浅绿色 米白 粉红 黄色</p></li><li title=" 无"><p>有无夹层: 无</p></li><li title=" 硬"><p>硬度: 硬</p></li><li title=" 否"><p>可否折叠: 否</p></li><li title=" 101-300元"><p>价格区间: 101-300元</p></li><li title=" 全新"><p>成色: 全新</p></li><li title=" 休闲/街头"><p>箱包场合: 休闲/街头</p></li><li title=" 茵佳怡"><p>品牌: 茵佳怡</p></li><li title=" JC309616"><p>货号: JC309616</p></li><li title=" 日韩风范"><p>箱包风格: 日韩风范</p></li><li title=" 贝壳"><p>箱包外形: 贝壳</p></li><li title=" 涤纶"><p>里料质地: 涤纶</p></li></ul></div><p><br /></p>', 'T555555', 'a:3:{s:4:\\"file\\";a:2:{i:0;s:96:\\"http://img04.taobaocdn.com/bao/uploaded/i4/14410028736686291/T1W6fiFoVdXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:83:\\"http://img04.taobaocdn.com/imgextra/i4/689704410/T2YTFEXCNXXXXXXXXX_!!689704410.jpg\\";}s:3:\\"pan\\";a:2:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";}s:5:\\"title\\";a:2:{i:0;s:5:\\"21231\\";i:1;s:4:\\"3333\\";}}', '', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(15, 1, 42, '<h2><span style="font-family:microsoft yahei;"><strong><span style="font-size:18.0px;">雅芳小红裙走珠香水</span></strong></span></h2><p><span style="font-family:microsoft yahei;"></span>【香 调】热情花香调 <br /> 【前 味】轻柔的红树莓，柑橘及洋李汁带出，清醇扑鼻 <br /> 【中 味】纯正保加利亚玫瑰，红茉莉，白铃兰，繁花汇集 <br /> 【后 味】红檀香，琥珀香草和麝香的性感诱惑 </p><h2 style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:微软雅黑;font-size:20.0px;color:#000000;width:540.0px;line-height:30.0px;max-height:120.0px;overflow-x:hidden;overflow-y:hidden;word-wrap:break-word;word-break:break-all;margin-top:0.0px;margin-bottom:10.0px;"><span style="font-size:18.0px;">雅芳香品走珠香水小黑裙</span></h2><p> 【香 调】花果木香调 <br /> 【前 味】金银花，樱草，杏花，非洲姜花 <br /> 【中 味】粉牡丹，依兰，栀子花，印度尼西亚茉莉 <br /> 【后 味】羊仔麝香，汤加豆，日本梅子，瓜哇檀香，奶香木 &nbsp;</p><h2><span style="font-size:18.0px;"><span style="font-family:microsoft yahei;"><strong>雅芳小黑裙香水10ml限量版</strong></span></span></h2><p><span style="font-size:18.0px;"><span style="font-family:microsoft yahei;"></span></span>【香 调】花果木香调 <br /> 【前 味】金银花，樱草，杏花，非洲姜花 <br /> 【中 味】粉牡丹，依兰，栀子花，印度尼西亚茉莉 <br /> 【后 味】羊仔麝香，汤加豆，日本梅子，瓜哇檀香，奶香木 &nbsp;</p><h2 style="font-size:20.0px;outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:微软雅黑;color:#000000;width:540.0px;line-height:30.0px;max-height:120.0px;overflow-x:hidden;overflow-y:hidden;word-wrap:break-word;word-break:break-all;margin-top:0.0px;margin-bottom:10.0px;"><span style="font-size:18.0px;">雅芳地球女人走珠香水</span></h2><p><span style="font-size:18.0px;"></span>【香 调】花果香调 <br /> 【前 味】加州无花果、 意大利佛手柑、 巴西香橙 <br /> 【中 味】英国甜豌豆花蕾、 法国苹果花苞、 安地斯山脉、雪花、埃及茉莉、中国月桂花 <br /> 【后 味】波斯蜜桃、 马达加斯加香草、麝香 </p><h2 style="font-size:20.0px;outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:微软雅黑;color:#000000;width:540.0px;line-height:30.0px;max-height:120.0px;overflow-x:hidden;overflow-y:hidden;word-wrap:break-word;word-break:break-all;margin-top:0.0px;margin-bottom:10.0px;"><span style="font-size:18.0px;">雅芳走珠香水白裙之恋</span></h2><p><span style="font-size:18.0px;"></span>【香 &nbsp; &nbsp;调】：东方香调 <br /> 【前 &nbsp; &nbsp;味】：香柠、甘桔 <br /> 【中 &nbsp; &nbsp;味】：托斯卡尼白色蒲公英、香水百合、白牡丹 <br /> 【尾 &nbsp; &nbsp;味】：白木、香草、檀香、麝香 </p><h2 style="font-size:20.0px;outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:微软雅黑;color:#000000;width:540.0px;line-height:30.0px;max-height:120.0px;overflow-x:hidden;overflow-y:hidden;word-wrap:break-word;word-break:break-all;margin-top:0.0px;margin-bottom:10.0px;"><span style="font-size:18.0px;">雅芳小白裙香水10ml限量版</span></h2><p><span style="font-size:18.0px;"></span>【香 &nbsp; &nbsp;调】：东方香调 <br /> 【前 &nbsp; &nbsp;味】：香柠、甘桔 <br /> 【中 &nbsp; &nbsp;味】：托斯卡尼白色蒲公英、香水百合、白牡丹 <br /> 【尾 &nbsp; &nbsp;味】：白木、香草、檀香、麝香 </p><h2 style="font-size:20.0px;outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:微软雅黑;color:#000000;width:540.0px;line-height:30.0px;max-height:120.0px;overflow-x:hidden;overflow-y:hidden;word-wrap:break-word;word-break:break-all;margin-top:0.0px;margin-bottom:10.0px;"><span style="font-size:18.0px;">雅芳梦之旅走珠香水</span></h2><p><span style="font-size:18.0px;"></span>【香 调】迷人花香调 <br /> 【前 味】柑橘，蜜桃，芒果 <br /> 【中 味】小苍兰，栀子花，橙花 <br /> 【后 味】麝香，乳木檀香，琥珀 </p><h2 style="font-size:20.0px;outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:微软雅黑;color:#000000;width:540.0px;line-height:30.0px;max-height:120.0px;overflow-x:hidden;overflow-y:hidden;word-wrap:break-word;word-break:break-all;margin-top:0.0px;margin-bottom:10.0px;"><span style="font-size:18.0px;">雅芳小红裙香水10ml限量版</span></h2><p><span style="font-size:18.0px;"></span>【香 调】热情花香调 <br /> 【前 味】轻柔的红树莓，柑橘及洋李汁带出，清醇扑鼻 <br /> 【中 味】纯正保加利亚玫瑰，红茉莉，白铃兰，繁花汇集 <br /> 【后 味】红檀香，琥珀香草和麝香的性感诱惑 </p><h2 style="font-size:20.0px;outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:微软雅黑;color:#000000;width:540.0px;line-height:30.0px;max-height:120.0px;overflow-x:hidden;overflow-y:hidden;word-wrap:break-word;word-break:break-all;margin-top:0.0px;margin-bottom:10.0px;"><span style="font-size:18.0px;">雅芳鸡尾酒香系列玫瑰露</span></h2><p><span style="font-size:18.0px;"></span></p><div style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:verdana   宋体;font-size:12.0px;color:#000000;line-height:24.0px;padding:0.0px;margin:0.0px;"><span style="font-size:14.0px;">【香调】 迷人花果香调</span></div><div style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:verdana   宋体;font-size:12.0px;color:#000000;line-height:24.0px;padding:0.0px;margin:0.0px;"><span style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:arial;padding:0.0px;margin:0.0px;"><span style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:verdana   宋体;font-size:14.0px;padding:0.0px;margin:0.0px;">【前调】 新鲜菠萝，芒果和番石榴</span></span></div><div style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:verdana   宋体;font-size:12.0px;color:#000000;line-height:24.0px;padding:0.0px;margin:0.0px;"><span style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:arial;padding:0.0px;margin:0.0px;"><span style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:verdana   宋体;font-size:14.0px;padding:0.0px;margin:0.0px;">【中调】小苍兰，玫瑰花瓣，紫罗兰</span></span></div><div style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:verdana   宋体;font-size:12.0px;color:#000000;line-height:24.0px;padding:0.0px;margin:0.0px;"><span style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:arial;padding:0.0px;margin:0.0px;"><span style="outline-style:none;outline-width:initial;outline-color:initial;list-style-type:none;list-style-position:initial;list-style-image:initial;border-top-style:none;border-right-style:none;border-bottom-style:none;border-left-style:none;font-family:verdana   宋体;font-size:14.0px;padding:0.0px;margin:0.0px;">【后调】 木质香，麝香，香草</span></span></div>', '', 'a:3:{s:4:\\"file\\";a:2:{i:0;s:94:\\"http://gi3.md.alicdn.com/bao/uploaded/i3/12659039022320170/T1HlCoFfFeXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:81:\\"http://gi1.md.alicdn.com/imgextra/i1/763042659/T2TMu9XnpXXXXXXXXX_!!763042659.jpg\\";}s:3:\\"pan\\";a:2:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";}s:5:\\"title\\";a:2:{i:0;s:4:\\"1111\\";i:1;s:4:\\"3333\\";}}', '', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(16, 1, 42, '<p style="text-align:center;"><span style="color:#0b5394;"><strong><span style="font-family:kaiti_gb2312;"><span style="font-size:24.0px;"><span style="font-family:microsoft yahei;"><span style="font-size:24.0px;"><span style="color:#ff0000;"><span style="line-height:1.5;"><span style="color:#ff0000;"><strong><span style="font-size:36.0px;">正品格拉斯固体香膏~8.5元为批发价，6、7元钱都是假货！此款店铺为全网最低了，</span></strong></span></span></span></span></span></span></span></strong></span></p><p style="text-align:center;"><span style="color:#0b5394;"><strong><span style="font-family:kaiti_gb2312;"><span style="font-size:24.0px;"><span style="font-family:microsoft yahei;"><span style="font-size:24.0px;"><span style="color:#ff0000;"><span style="line-height:1.5;"><span style="color:#ff0000;"><strong><span style="font-size:36.0px;">假一赔万，支持各种渠道验货。不再回答是不是正品的问题了~</span></strong></span></span></span></span></span></span></span></strong></span></p><p><span style="color:#0b5394;"><strong><span style="font-family:kaiti_gb2312;"><span style="font-size:24.0px;"><span style="font-family:microsoft yahei;"><span style="font-size:24.0px;"><span style="color:#ff0000;"><span style="line-height:1.5;"></span></span></span></span></span></span></strong></span></p><p><span style="color:#0b5394;"><strong><span style="font-family:kaiti_gb2312;"><span style="font-size:24.0px;"><span style="font-family:microsoft yahei;"><span style="font-size:24.0px;"><span style="color:#ff0000;"><span style="line-height:1.5;">原罐体上所印刷的夏莫尼香膏官网服务器在国外，造成有时登录不上，加上没有专门开辟真伪查询，现已经正式放弃使用，</span><span style="line-height:1.5;">现在中国建立一个新的夏莫尼香膏官方域名</span></span><a style="line-height:1.5;font-family:宋体;font-size:13px;" title="阿里旺旺无法确定该链接的安全性" target="_blank"><span style="color:#000000;">www.chamonix-france.net（把网址复制到浏览器打开）</span></a><span style="color:#ff0000;"><span style="line-height:1.5;">现有铁盒底盖包装会陆续修改，真伪查询以产地证明和生产日期为主如下图：（除少量三四款香型为前2月生产，罐身塑封上还没有打印生产日期和仿伪码，其它香型塑封上均已打印好日期及仿伪码。）</span></span></span></span></span></span></strong></span></p><p><br /></p>', '', 'a:3:{s:4:\\"file\\";a:1:{i:0;s:96:\\"http://img01.taobaocdn.com/bao/uploaded/i1/19114026056555156/T1NGpAFnxeXXXXXXXX_!!0-item_pic.jpg\\";}s:3:\\"pan\\";a:1:{i:0;s:0:\\"\\";}s:5:\\"title\\";a:1:{i:0;s:6:\\"123123\\";}}', '', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(17, 1, 42, '<div id="attributes" class="attributes"><ul class="attributes-list list-paddingleft-2"><li title="YangSang/杨桑 矿物丝柔散粉 13G"><p>产品名称：YangSang/杨桑 矿物丝柔散...</p></li><li title=" 2号柔白（送散粉扑1个） 2号柔白（送面膜1片） 1号蜜色（送散粉扑1个） 1号蜜色（送面膜1片） 1号蜜色（适合肤色自然、偏黄） 2号柔白（适合肤色偏白）"><p>颜色分类: 2号柔白（送散粉扑1个） 2号柔白（送面膜1片） 1号蜜色（送散粉扑1个） 1号蜜色（送面膜1片） 1号蜜色（适合肤色自然、偏黄） 2号柔白（适合肤色偏白）</p></li><li title=" 哑光"><p>蜜粉/散粉分类: 哑光</p></li><li title=" 正常规格"><p>彩妆规格: 正常规格</p></li><li title=" YANGSANG/杨桑"><p>品牌: YANGSANG/杨桑</p></li><li title=" 矿物丝柔散粉 13G"><p>蜜粉/散粉单品: 矿物丝柔散粉 13G</p></li><li title=" 控油 美白 其他功效 防晒"><p>化妆品功效: 控油 美白 其他功效 防晒</p></li><li title=" 持久度 使用效果"><p>化妆品特性: 持久度 使用效果</p></li><li title=" 所有肤质"><p>适合肤质: 所有肤质</p></li><li title=" 中国"><p>省份: 中国</p></li><li title=" 三年"><p>保质期时间: 三年</p></li></ul></div><p><br /></p>', '', 'a:3:{s:4:\\"file\\";a:3:{i:0;s:96:\\"http://img03.taobaocdn.com/bao/uploaded/i3/19556029081387003/T1fmneFdJeXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:83:\\"http://img02.taobaocdn.com/imgextra/i2/236589556/T2m2lyXu0aXXXXXXXX_!!236589556.jpg\\";i:2;s:83:\\"http://img01.taobaocdn.com/imgextra/i1/236589556/T28Y4dXvlaXXXXXXXX_!!236589556.jpg\\";}s:3:\\"pan\\";a:3:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";i:2;s:0:\\"\\";}s:5:\\"title\\";a:3:{i:0;s:4:\\"1111\\";i:1;s:4:\\"2322\\";i:2;s:3:\\"333\\";}}', '', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(18, 1, 45, '<p>一支19.9，两支35拍下自动优惠，无须改价！套餐：购买BEELY终极眼线膏+BEELY七效合一祼妆BB霜套餐仅需45元 →点此进入←</p>', '', 'a:3:{s:4:\\"file\\";a:2:{i:0;s:96:\\"http://img04.taobaocdn.com/bao/uploaded/i4/19086029468047851/T1S0GxFbJgXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:63:\\"http://img.taobaocdn.com/imgextra/T165PjXaJfXXXvB36X_085335.jpg\\";}s:3:\\"pan\\";a:2:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";}s:5:\\"title\\";a:2:{i:0;s:5:\\"12323\\";i:1;s:4:\\"3444\\";}}', '', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(19, 1, 59, '<p><span style="line-height:27.0px;font-family:microsoft yahei;color:#cc0000;font-size:18.0px;text-decoration:underline;text-decoration:underline;font-size:18px;color:#0000ff;"><span style="font-family:simhei;"><span style="font-size:18.0px;"><strong><span style="font-size:36.0px;color:#ff0000;font-family:微软雅黑;">送大礼包</span>：</strong></span></span></span><span style="font-size:24.0px;"><strong style="color:#404040;"><span style="color:#ff0000;"><span style="font-family:宋体;"><span style="font-family:微软雅黑;font-weight:normal;"><span style="font-family:microsoft yahei;">送：保护膜+电容笔+电影支架+读卡器+精美挂饰+</span></span></span></span></strong></span><span style="font-size:24.0px;"><strong style="color:#404040;"><span style="color:#ff0000;"><span style="font-family:宋体;"><span style="font-family:微软雅黑;font-weight:normal;"><span style="font-family:microsoft yahei;">翻盖皮套+2600毫安移动电源+到货24小时全满分五星好评返现20元+送一张双色球彩票(五星满分好评满10字以上系统自动赠送)</span></span></span></span></strong></span></p><div style="color:#404040;text-align:center;" align="center"><span style="font-size:24.0px;font-family:simhei;color:#000000;font-family:simhei;color:#000000;color:#000000;"><strong><strong><span style="color:#0000ff;font-family:微软雅黑;"><strong style="line-height:1.5;color:#ff0000;"><span style="background-color:#ff0000;color:#ffff00;"><span style="line-height:1.5;">华为定制版，运行内存</span></span></strong><strong style="line-height:1.5;color:#ff0000;"><span style="background-color:#ff0000;color:#ffff00;">1G运行内存</span></strong><strong style="line-height:1.5;color:#ff0000;"><span style="background-color:#ff0000;color:#ffff00;"><span style="line-height:1.5;">，机身4G。如果您要官方版亲不用往下看了，官方是800元左右！</span></span></strong></span></strong></strong></span></div><p><br /></p>', '', 'a:3:{s:4:\\"file\\";a:2:{i:0;s:70:\\"http://img.taobaocdn.com/bao/uploaded/i6/T1od5LFhNbXXc5RhQ0_035502.jpg\\";i:1;s:70:\\"http://img.taobaocdn.com/bao/uploaded/i3/T1uz1IFbdhXXaajrA0_034402.jpg\\";}s:3:\\"pan\\";a:2:{i:0;s:0:\\"\\";i:1;s:0:\\"\\";}s:5:\\"title\\";a:2:{i:0;s:6:\\"121323\\";i:1;s:6:\\"123123\\";}}', 'a:4:{s:2:\\"id\\";a:3:{i:0;s:2:\\"37\\";i:1;s:2:\\"42\\";i:2;s:2:\\"45\\";}s:5:\\"price\\";a:1:{s:8:\\"37-42-45\\";s:3:\\"222\\";}s:8:\\"quantity\\";a:1:{s:8:\\"37-42-45\\";s:2:\\"22\\";}s:6:\\"number\\";a:1:{s:8:\\"37-42-45\\";s:0:\\"\\";}}', '');
REPLACE INTO `{tablename}_data_0` (`id`, `uid`, `catid`, `content`, `number`, `images`, `format`, `discount`) VALUES(20, 1, 59, '<ul class="attributes-list list-paddingleft-2"><li title="MIUI/小米 2S(MI2S)"><p>产品名称：MIUI/小米 2S(MI2S)</p></li><li title=" MIUI/小米"><p>品牌: MIUI/小米</p></li><li title=" 2S(MI2S)"><p> 型号: 2S(MI2S)</p></li><li title=" 1001-2000元"><p>手机价格区间: 1001-2000元</p></li><li title=" 2013年"><p>上市时间: 2013年</p></li><li title=" 4月"><p>13年上市月份: 4月</p></li><li title=" 联通3G GSM/WCDMA(3G)"><p>网络类型: 联通3G GSM/WCDMA(3G)</p></li><li title=" 直板"><p>外观样式: 直板</p></li><li title=" 4.3英寸"><p>主屏尺寸: 4.3英寸</p></li><li title=" 白色 黑色"><p>机身颜色: 白色 黑色</p></li><li title=" 官方标配 套餐一 套餐二 套餐五"><p>手机套餐: 官方标配 套餐一 套餐二 套餐五</p></li><li title=" 800w-1300w"><p>后置摄像头: 800w-1300w</p></li><li title=" Android/安卓"><p>操作系统: Android/安卓</p></li><li title=" GPRS上网"><p>高级功能: GPRS上网</p></li><li title=" 全新"><p>宝贝成色: 全新</p></li><li title=" 店铺三包"><p>售后服务: 店铺三包</p></li><li title=" 电容式触摸屏"><p>触摸屏: 电容式触摸屏</p></li><li title=" 2G"><p>运行内存RAM: 2G</p></li><li title=" 16G 32G"><p>机身内存: 16G 32G</p></li><li title=" 虚拟触屏键盘"><p>键盘类型: 虚拟触屏键盘</p></li><li title=" 普通(大于1cm)"><p>厚度: 普通(大于1cm)</p></li><li title=" 1280×720像素"><p>主屏分辨率: 1280×720像素</p></li><li title=" 3G"><p>手机类型: 3G</p></li><li title=" 可拆卸式电池"><p>电池类型: 可拆卸式电池</p></li><li title=" 双摄像头（前后）"><p>摄像头类型: 双摄像头（前后）</p></li><li title=" 1080P(全高清D5)"><p>视频拍摄: 1080P(全高清D5)</p></li><li title=" 单卡双模"><p>网络模式: 单卡双模</p></li><li title=" 四核"><p>cpu核心数: 四核</p></li><li title=" 1.7G"><p>四核cpu频率: 1.7G</p></li><li title=" 中国大陆"><p>版本: 中国大陆</p></li></ul><p><br /></p>', '', 'a:2:{s:4:\\"file\\";a:2:{i:0;s:96:\\"http://img01.taobaocdn.com/bao/uploaded/i1/19892026520657388/T1MlmdFitbXXXXXXXX_!!0-item_pic.jpg\\";i:1;s:83:\\"http://img02.taobaocdn.com/imgextra/i2/282539892/T2hqE5XXBXXXXXXXXX_!!282539892.jpg\\";}s:5:\\"title\\";a:2:{i:0;s:8:\\"12312312\\";i:1;s:9:\\"213123123\\";}}', 'a:4:{s:2:\\"id\\";a:5:{i:0;s:2:\\"36\\";i:1;s:2:\\"37\\";i:2;s:2:\\"42\\";i:3;s:2:\\"43\\";i:4;s:2:\\"45\\";}s:5:\\"price\\";a:4:{s:8:\\"36-42-45\\";s:3:\\"123\\";s:8:\\"36-43-45\\";s:4:\\"1231\\";s:8:\\"37-42-45\\";s:4:\\"2312\\";s:8:\\"37-43-45\\";s:4:\\"3123\\";}s:8:\\"quantity\\";a:4:{s:8:\\"36-42-45\\";s:3:\\"123\\";s:8:\\"36-43-45\\";s:3:\\"123\\";s:8:\\"37-42-45\\";s:3:\\"312\\";s:8:\\"37-43-45\\";s:3:\\"123\\";}s:6:\\"number\\";a:4:{s:8:\\"36-42-45\\";s:0:\\"\\";s:8:\\"36-43-45\\";s:0:\\"\\";s:8:\\"37-42-45\\";s:0:\\"\\";s:8:\\"37-43-45\\";s:0:\\"\\";}}', 'a:11:{s:3:\\"use\\";s:1:\\"1\\";s:3:\\"3_1\\";s:1:\\"1\\";s:3:\\"3_2\\";s:1:\\"2\\";s:3:\\"3_3\\";s:1:\\"3\\";s:3:\\"3_4\\";s:1:\\"4\\";s:3:\\"4_5\\";s:1:\\"2\\";s:3:\\"4_6\\";s:1:\\"5\\";s:3:\\"4_7\\";s:1:\\"5\\";s:3:\\"4_8\\";s:1:\\"5\\";s:4:\\"star\\";s:10:\\"1381288440\\";s:3:\\"end\\";s:10:\\"1382238840\\";}');

REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(1, 1, 53, 9, 1381893932);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(2, 1, 53, 9, 1381894303);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(3, 1, 8, 9, 1381903941);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(4, 1, 8, 9, 1381904152);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(5, 1, 13, 9, 1381904292);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(6, 1, 12, 9, 1381904463);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(7, 1, 21, 9, 1381904664);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(8, 1, 21, 9, 1381904802);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(9, 1, 21, 9, 1381904926);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(10, 1, 25, 9, 1381905071);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(11, 1, 25, 9, 1381905183);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(12, 1, 25, 9, 1381905291);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(13, 1, 25, 9, 1381905422);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(14, 1, 25, 9, 1381905538);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(15, 1, 42, 9, 1381906241);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(16, 1, 42, 9, 1381906540);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(17, 1, 42, 9, 1381906598);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(18, 1, 45, 9, 1381906727);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(19, 1, 59, 9, 1381907143);
REPLACE INTO `{tablename}_index` (`id`, `uid`, `catid`, `status`, `inputtime`) VALUES(20, 1, 59, 9, 1381907260);

UPDATE `{dbprefix}module` SET `setting`='a:5:{s:4:\\"flag\\";a:9:{i:1;a:9:{s:4:\\"name\\";s:14:\\"1F潮流服装\\";s:3:\\"3_1\\";s:1:\\"0\\";s:3:\\"3_2\\";s:1:\\"0\\";s:3:\\"3_3\\";s:1:\\"0\\";s:3:\\"3_4\\";s:1:\\"0\\";s:3:\\"4_5\\";s:1:\\"0\\";s:3:\\"4_6\\";s:1:\\"0\\";s:3:\\"4_7\\";s:1:\\"0\\";s:3:\\"4_8\\";s:1:\\"0\\";}i:2;a:9:{s:4:\\"name\\";s:14:\\"2F鞋包配饰\\";s:3:\\"3_1\\";s:1:\\"0\\";s:3:\\"3_2\\";s:1:\\"0\\";s:3:\\"3_3\\";s:1:\\"0\\";s:3:\\"3_4\\";s:1:\\"0\\";s:3:\\"4_5\\";s:1:\\"0\\";s:3:\\"4_6\\";s:1:\\"0\\";s:3:\\"4_7\\";s:1:\\"0\\";s:3:\\"4_8\\";s:1:\\"0\\";}i:3;a:9:{s:4:\\"name\\";s:14:\\"3F美容美妆\\";s:3:\\"3_1\\";s:1:\\"0\\";s:3:\\"3_2\\";s:1:\\"0\\";s:3:\\"3_3\\";s:1:\\"0\\";s:3:\\"3_4\\";s:1:\\"0\\";s:3:\\"4_5\\";s:1:\\"0\\";s:3:\\"4_6\\";s:1:\\"0\\";s:3:\\"4_7\\";s:1:\\"0\\";s:3:\\"4_8\\";s:1:\\"0\\";}i:4;a:9:{s:4:\\"name\\";s:14:\\"4F数码家电\\";s:3:\\"3_1\\";s:1:\\"0\\";s:3:\\"3_2\\";s:1:\\"0\\";s:3:\\"3_3\\";s:1:\\"0\\";s:3:\\"3_4\\";s:1:\\"0\\";s:3:\\"4_5\\";s:1:\\"0\\";s:3:\\"4_6\\";s:1:\\"0\\";s:3:\\"4_7\\";s:1:\\"0\\";s:3:\\"4_8\\";s:1:\\"0\\";}i:5;a:9:{s:4:\\"name\\";s:0:\\"\\";s:3:\\"3_1\\";s:1:\\"0\\";s:3:\\"3_2\\";s:1:\\"0\\";s:3:\\"3_3\\";s:1:\\"0\\";s:3:\\"3_4\\";s:1:\\"0\\";s:3:\\"4_5\\";s:1:\\"0\\";s:3:\\"4_6\\";s:1:\\"0\\";s:3:\\"4_7\\";s:1:\\"0\\";s:3:\\"4_8\\";s:1:\\"0\\";}i:6;a:9:{s:4:\\"name\\";s:0:\\"\\";s:3:\\"3_1\\";s:1:\\"0\\";s:3:\\"3_2\\";s:1:\\"0\\";s:3:\\"3_3\\";s:1:\\"0\\";s:3:\\"3_4\\";s:1:\\"0\\";s:3:\\"4_5\\";s:1:\\"0\\";s:3:\\"4_6\\";s:1:\\"0\\";s:3:\\"4_7\\";s:1:\\"0\\";s:3:\\"4_8\\";s:1:\\"0\\";}i:7;a:9:{s:4:\\"name\\";s:0:\\"\\";s:3:\\"3_1\\";s:1:\\"0\\";s:3:\\"3_2\\";s:1:\\"0\\";s:3:\\"3_3\\";s:1:\\"0\\";s:3:\\"3_4\\";s:1:\\"0\\";s:3:\\"4_5\\";s:1:\\"0\\";s:3:\\"4_6\\";s:1:\\"0\\";s:3:\\"4_7\\";s:1:\\"0\\";s:3:\\"4_8\\";s:1:\\"0\\";}i:8;a:9:{s:4:\\"name\\";s:0:\\"\\";s:3:\\"3_1\\";s:1:\\"0\\";s:3:\\"3_2\\";s:1:\\"0\\";s:3:\\"3_3\\";s:1:\\"0\\";s:3:\\"3_4\\";s:1:\\"0\\";s:3:\\"4_5\\";s:1:\\"0\\";s:3:\\"4_6\\";s:1:\\"0\\";s:3:\\"4_7\\";s:1:\\"0\\";s:3:\\"4_8\\";s:1:\\"0\\";}i:9;a:9:{s:4:\\"name\\";s:0:\\"\\";s:3:\\"3_1\\";s:1:\\"0\\";s:3:\\"3_2\\";s:1:\\"0\\";s:3:\\"3_3\\";s:1:\\"0\\";s:3:\\"3_4\\";s:1:\\"0\\";s:3:\\"4_5\\";s:1:\\"0\\";s:3:\\"4_6\\";s:1:\\"0\\";s:3:\\"4_7\\";s:1:\\"0\\";s:3:\\"4_8\\";s:1:\\"0\\";}}s:3:\\"seo\\";a:3:{s:12:\\"module_title\\";s:0:\\"\\";s:15:\\"module_keywords\\";s:0:\\"\\";s:18:\\"module_description\\";s:0:\\"\\";}s:3:\\"tag\\";a:3:{s:8:\\"pagesize\\";s:0:\\"\\";s:3:\\"url\\";s:0:\\"\\";s:8:\\"url_page\\";s:0:\\"\\";}s:6:\\"search\\";a:4:{s:5:\\"cache\\";s:5:\\"10000\\";s:5:\\"total\\";s:3:\\"500\\";s:6:\\"length\\";s:1:\\"4\\";s:7:\\"rewrite\\";s:1:\\"0\\";}s:10:\\"show_cache\\";s:5:\\"10000\\";}' WHERE `dirname`='{moduledir}';


CREATE TABLE IF NOT EXISTS `{tablename}_config` (
  `name` varchar(50) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='模块配置参数表';

INSERT INTO `{tablename}_config` VALUES('paytype', 'a:3:{i:1;a:3:{s:4:\\"name\\";s:12:\\"余额支付\\";s:3:\\"use\\";s:1:\\"1\\";s:4:\\"text\\";s:0:\\"\\";}i:2;a:2:{s:4:\\"name\\";s:12:\\"在线支付\\";s:4:\\"text\\";s:0:\\"\\";}i:3;a:3:{s:4:\\"name\\";s:12:\\"货到付款\\";s:3:\\"use\\";s:1:\\"3\\";s:4:\\"text\\";s:0:\\"\\";}}');
INSERT INTO `{tablename}_config` VALUES('expresses', 'a:3:{s:4:\\"list\\";s:37:\\"yuantong,yunda,zhongtong,shunfeng,ems\\";s:2:\\"id\\";s:6:\\"103253\\";s:6:\\"secret\\";s:32:\\"fe55a16163d94c3d9af269345df22716\\";}');
INSERT INTO `{tablename}_config` VALUES('config', 'a:7:{s:8:\\"quantity\\";s:1:\\"1\\";s:3:\\"num\\";s:1:\\"1\\";s:7:\\"freight\\";s:1:\\"1\\";s:4:\\"code\\";s:1:\\"0\\";s:6:\\"status\\";s:1:\\"0\\";s:8:\\"isreview\\";s:1:\\"1\\";s:6:\\"review\\";s:67:\\"宝贝与描述相符\r\n卖家的服务态度\r\n卖家发货的速度\\";}');

